/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include <signal/signal_protocol.h>

namespace Signal {

    class Context {
    public:
        Context();
        ~Context();
        Context(const Context &) = delete;
        Context(Context &&) = delete;
        Context &operator=(const Context &) = delete;

    private:
        signal_context *ctx{nullptr};
    };

} // namespace Signal
