/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include <signal/signal_protocol.h>

namespace Signal::Store {

    class IdentityKeyStore {
    public:
        static void boundToContext(signal_protocol_store_context *ctx);

        int getIdentityKeyPair(signal_buffer **public_data, signal_buffer **private_data);
        int getLocalRegistrationId(uint32_t *registration_id);
        int saveIdentity(const signal_protocol_address *address, uint8_t *key_data, size_t key_len);
        int isTrustedIdentity(const signal_protocol_address *address, uint8_t *key_data, size_t key_len);
    };

} // namespace Signal::Store
