/*
 * Created by victoria on 2021-05-13.
 */

#pragma once

#include <signal/signal_protocol.h>

namespace Signal::Store {

    class PreKeyStore {
    public:
        static void boundToContext(signal_protocol_store_context *ctx);

        int containsPreKey(uint32_t pre_key_id);
        int loadPreKey(signal_buffer **record, uint32_t pre_key_id);
        int storePreKey(uint32_t pre_key_id, uint8_t *record, size_t record_len);
        int removePreKey(uint32_t pre_key_id);
    };

} // namespace Signal::Store
